package com.ylx.massage.utils;


import com.ylx.common.core.redis.RedisCache;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.math.RoundingMode;

/**
 * @author jianlong
 * @date 2024-04-15 14:38
 */

public class  MassageUtil {

//    public static void main(String[] args) {
//        // 测试计算4.04公里的费用
//        BigDecimal totalCost = calculateTaxiFare(BigDecimal.valueOf(4.04));
//        System.out.println("全程4.04公里的费用为: " + totalCost + "元");
//    }

    /**
     * 计算出租车费用
     * @param distance 全程距离（公里）
     * @return 费用总额（元）
     */
    public static BigDecimal calculateTaxiFare(BigDecimal distance) {
        final BigDecimal BASE_FARE = new BigDecimal("9.3"); // 起步价
        final BigDecimal ADDITIONAL_FARE_PER_KM = new BigDecimal("2.4"); // 超出起步价后每公里费用
        final BigDecimal BASE_DISTANCE_KM = new BigDecimal("3"); // 起步距离（公里）

        // 计算超出起步价的公里数，注意应该向上取整，因为不足1公里也要按1公里计费
        BigDecimal extraKms = distance.subtract(BASE_DISTANCE_KM).setScale(0, RoundingMode.UP);

        // 计算总费用

        BigDecimal totalFare = BASE_FARE;
        if(extraKms.compareTo(BigDecimal.ZERO) > 0) {
            totalFare= totalFare.add(extraKms.multiply(ADDITIONAL_FARE_PER_KM));
        }

        return totalFare;
    }
}
